#include "display.h"
#include "storage.h"

#include "var.h"

namespace addr
{

void show_input()
{
	using namespace sys;
	Display d;
	d.showDisplay(storage::enter_name);
}

void input()
{
	show_input();

	Var v;
	v.readName();
}

int read_compare(int i)
{
	using namespace sys;
	Flash f;
	f.read(i);

	Var v;
	return v.compare();
}

int do_loop(int i)
{
	using namespace sys;

	if (read_compare(i))
	{
		Display d;
		// d.showDisplay(i);
		d.blankDisplay('X');
		getchar();
		return 1;
	}

	Display d;
	// d.showDisplay(i);
	d.blankDisplay('o');
	getchar();

	return 0;
}

void search()
{
	using namespace sys;
	int i;
	for (i=storage::data0; i!=storage::dataend; i++)
	{
		if (do_loop(i)) return;
	}

	Display d;
	d.showDisplay(storage::not_found);
}

void person_search()
{
	input();
	search();

	sys::getchar();
}

int input_number()
{
	using namespace sys;
	Display d;
	d.showDisplay(storage::enter_number);
	return sys::read_number();
}

void person_show()
{
	using namespace sys;

	int who = input_number();
	who = add(who, storage::data0);

	Display d;
	d.showDisplay(who);
	getchar();
}

int main()
{
	using namespace sys;


	while (true)
	{
		Display d;
		d.showDisplay(storage::addressbook_welcome);
		int todo = sys::getchar();
		int ignore = sys::getchar();

		if (todo == 'F') person_search();
		else if (todo == 'S') person_show();
		else if (todo == 'V') return 0;
	}
}



} // end namespace addr
