#include "display.h"
#include "input.h"
#include "math.h"

#include "storage.h"

namespace calc
{

int input_number()
{
	using namespace sys;
	Display d;
	d.showDisplay(storage::enter_number);
	return sys::read_number();
}

int input_operator()
{
	using namespace sys;
	Display d;
	d.showDisplay(storage::enter_operator);
	int op = sys::getchar();
	int ig = sys::getchar();

	return op;
}

int show_unkown_op()
{
	using namespace sys;
	Display d;
	d.showDisplay(storage::error_unknown_op);
	sys::getchar();

	return 1;
}

int show_number(int nr)
{
	using namespace sys;
	Display d;
	d << 'R' << 'e' << 's' << ':' << ' ';
	int anz = d.get_anz(nr);
	// d.show_number (nr, anz);
	d << '.';

	sys::getchar();

	return anz;
}

int main()
{
	int nr1 = input_number();
	int op = input_operator();
	int nr2 = input_number();
	int res = 0;

	if (op == '+') res=sys::add(nr1, nr2);
	else if (op == '-') res=sys::sub (nr1, nr2);
	else if (op == '*') res=sys::mul (nr1, nr2);
	else if (op == '/') res=sys::div (nr1, nr2);
	else return show_unkown_op();

	return show_number(res);
}

} // end namespace calc
