#ifndef FLASH_H
#define FLASH_H

#include "math.h"

extern "C" {

int __read(int block);
int __write(int block);

} // end extern "C"

namespace addr
{
class Var;
} // end namespace addr

namespace sys
{

class Display;

class Flash
{
private:
	static char flash[128];

public:
	int read(int block);
	int write(int block);

	int change(int where, char to);

	friend class Display;
	friend class addr::Var;
};

/**Reads a block from the flash.
  It will be written into the array flash
  with the size 128.*/
int Flash::read(int block=0)
{
	return __read(block);
}

/**Writes a block to the flash.
  It will be read from the array flash
  with the size 128.*/
int Flash::write(int block=0)
{
	return __write(block);
}

int Flash::change (int where, char to)
{
	flash[where] = to;
}

char Flash::flash[128];

} // end namespace sys

#endif
