#ifndef OPCODE_H
#define OPCODE_H

#include "config.h"

#include <string>
#include <vector>
#include <map>

struct invalid : public std::exception
{
	int linenr;
	char reg;
	invalid() :
		linenr(0),
		reg(' ')
	{}
};

struct invalid_opcode : public invalid
{};

struct invalid_register : public invalid
{
	invalid_register(char reg)
	{
		this->reg = reg;
	}
};

class Opcode
{
	std::vector <word_t> opcodes;
	std::map <std::string, word_t> commands;
	std::map <std::string, word_t> registers;
	size_t where;
public:
	Opcode();
	void add (std::string op, std::string A, std::string B);
	char* buffer();
	size_t size();
};

#endif
