#ifndef CPU_H
#define CPU_H

#include <vector>

class Opcode;

class Register;
class Flash;
class Display;
class Keyboard;

/**Simulates the CPU*/
class CPU
{
	/**Beinhaltet die von der CPU
	  unterstützen opcodes.*/
	std::vector<Opcode*> opcodes;

	Register &reg;
	Flash &flash;
	Display &dis;
	Keyboard &key;
public:
	CPU(Register &reg, Flash &flash, Display &dis,
			Keyboard &key);
	~CPU();

	/**Executes the next Opcode.*/
	void exec();
};

#endif
