#ifndef FLASH_H
#define FLASH_H

#include <string>
#include <fstream>
#include <exception>

class Register;

class file_error : public std::exception
{
	const char *msg;
	file_error& operator=(const file_error&);
public:
	file_error(const char* msg) :
		msg(msg)
	{}
	file_error (file_error const&) :
		msg(msg)
	{}
	virtual const char* what() const throw()
	{
		return msg;
	}
};

class Flash
{
	std::fstream f;
public:
	Flash(std::string const& file);
	~Flash();
	void writeRegister(Register &reg);

	void writeBlock(Register &reg, size_t block, int from);
	void readBlock(Register &reg, size_t block, int to);
};

#endif
