#include "register.h"

#include <stdexcept>

#ifdef VERBOSE
#include <iostream>
#endif

using namespace std;

int& Register::operator[] (int pos)
{
#ifdef VERBOSE
	// this block here logs all access attempts to storage
	static int oldpos = pos;
	cout << dec << data[offset(oldpos)] << 'P' << pos << ' ';
	oldpos = pos;
#endif
	if (pos < lowaddr || pos > highaddr)
	{
		throw out_of_range
			("Tried to access register at invalid position");
	}
	return data[offset(pos)];
}

char* Register::buffer(int from)
{
	if (from < lowaddr || (from + regperblock) > highaddr)
	{
		throw out_of_range
			("Tried to copy register at invalid position");
	}
	return reinterpret_cast<char*>(&data[offset(from)]);
}

char* Register::display()
{
	return reinterpret_cast<char*>(&data[offset(lowdisplay)]);
}
